Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| deegree 2.4 (2010/11/11 10:47 build-27-official)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.deegree.io.datastore.sql.generic
Class GenericSQLTransaction

    java.lang.Object
      org.deegree.io.datastore.sql.AbstractRequestHandler
          org.deegree.io.datastore.sql.transaction.SQLTransaction
              org.deegree.io.datastore.sql.generic.GenericSQLTransaction

All Implemented Interfaces:
  DatastoreTransaction

    public class GenericSQLTransaction

extends SQLTransaction

Special transaction implementation for the `GenericSQLDatastore`.

Please note that the quadtree management isn't finished yet.

What should work:

- inserting of new features
- deleting of features
- updating features (unless the geometry property is changed)

What definitely won't work:

- updating geometry properties will most probably break the index

Version:
  $Revision: 18836 $, $Date: 2009-07-31 12:28:01 +0200 (Fr, 31. Jul 2009) $
Author:
  Andreas Poth, Markus Schneider, Rutger Bezema, last edited by: $Author: awietschke $
See Also:
  `org.deegree.io.quadtree`

Field Summary
`static HashMap<String,String>` | `quadTreeVersionInfo` saves versioninfos about the different quadtrees.

Fields inherited from class org.deegree.io.datastore.sql.AbstractRequestHandler
`aliasGenerator, conn, datastore, FT_COLUMN, FT_PREFIX`

Constructor Summary
`GenericSQLTransaction(AbstractSQLDatastore ds, TableAliasGenerator aliasGenerator, Connection conn)`

Method Summary
`int` | `performDelete(MappedFeatureType mappedFeatureType, Filter filter, String lockId)` Deletes the features from the datastore that are matched by the given filter and type.
`List<FeatureId>` | `performInsert(List<Feature> features)` Inserts the given feature instances into the datastore.
`int` | `performUpdate(MappedFeatureType mappedFeatureType, Feature replacementFeature, Filter filter, String lockId)` Performs a update (replace-style) operation against the datastore.
`int` | `performUpdate(MappedFeatureType mappedFeatureType, Map<PropertyPath,FeatureProperty> replacementProps, Filter filter, String lockId)` Performs an update operation against the datastore.

Methods inherited from class org.deegree.io.datastore.sql.transaction.SQLTransaction
`commit, getConnection, getDatastore, performNative, release, rollback`

Methods inherited from class org.deegree.io.datastore.sql.AbstractRequestHandler
`appendColumnsList, appendFeatureIdColumns, appendFeatureIdConstraint, appendFeatureIdConstraint, appendJoinCondition, appendJoins, appendQualifiedColumn, appendQualifiedColumnsList, determineAffectedAndModifiableFIDs, determineAffectedFIDs, determineSubFeatures, determineSuperFeatures, extractFeatureId, extractFeatureIds, extractFeatureIdsForceUnique`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### quadTreeVersionInfo

    public static HashMap<String,String> quadTreeVersionInfo

  saves versioninfos about the different quadtrees.

Constructor Detail

### GenericSQLTransaction

    GenericSQLTransaction(AbstractSQLDatastore ds,
                          TableAliasGenerator aliasGenerator,
                          Connection conn)
                    throws DatastoreException

Parameters:
  `ds` -
  `aliasGenerator` -
  `conn` -
Throws:
  `DatastoreException`

Method Detail

### performDelete

    public int performDelete(MappedFeatureType mappedFeatureType,
                             Filter filter,
                             String lockId)
                      throws DatastoreException

  Description copied from class: `SQLTransaction`
  Deletes the features from the datastore that are matched by the given filter and type.

  Specified by:
    `performDelete` in interface `DatastoreTransaction`
  Overrides:
    `performDelete` in class `SQLTransaction`
    `lockId` - optional id of associated lock (may be null)
  Returns:
    number of deleted feature instances
  Throws:
    `DatastoreException`

### performInsert

    public List<FeatureId> performInsert(List<Feature> features)
                                  throws DatastoreException

  Description copied from class: `SQLTransaction`
  Inserts the given feature instances into the datastore.

  Specified by:
    `performInsert` in interface `DatastoreTransaction`
  Overrides:
    `performInsert` in class `SQLTransaction`
  Returns:
    feature ids of the inserted (root) features
  Throws:
    `DatastoreException`
  See Also:
    `FeatureIdAssigner`

### performUpdate

    public int performUpdate(MappedFeatureType mappedFeatureType,
                             Feature replacementFeature,
                             Filter filter,
                             String lockId)
                      throws DatastoreException

  Description copied from class: `SQLTransaction`
  Performs a update (replace-style) operation against the datastore.

  Specified by:
    `performUpdate` in interface `DatastoreTransaction`
  Overrides:
    `performUpdate` in class `SQLTransaction`
  Parameters:
    `mappedFeatureType` - feature type that is to be replaced
    `replacementFeature` - feature instance that will be used to replace the properties of the selected features
    `filter` - selects the feature instances that are to be replaced
    `lockId` - optional id of associated lock (may be null)
  Returns:
    number of replaced feature instances
  Throws:
    `DatastoreException`

### performUpdate

    public int performUpdate(MappedFeatureType mappedFeatureType,
                             Map<PropertyPath,FeatureProperty> replacementProps,
                             Filter filter,
                             String lockId)
                      throws DatastoreException

  Description copied from class: `SQLTransaction`
  Performs an update operation against the datastore.

  Specified by:
    `performUpdate` in interface `DatastoreTransaction`
  Overrides:
    `performUpdate` in class `SQLTransaction`
  Parameters:
    `mappedFeatureType` - feature type that is to be updated
    `replacementProps` - properties and their replacement values
    `filter` - selects the feature instances that are to be updated
    `lockId` - optional id of associated lock (may be null)
  Returns:
    number of updated feature instances
  Throws:
    `DatastoreException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| deegree 2.4 (2010/11/11 10:47 build-27-official)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

an open source project founded by lat/lon, Bonn, Germany.
For more information visit: http://www.deegree.org